#ifndef SHIELD_POWERUP_HPP
#define SHIELD_POWERUP_HPP

#include <godot_cpp/classes/area3d.hpp>

namespace godot {
//! Object for the player's "shield" powerup. Collision area that destroys all cars that hit it.
class ShieldPowerup : public Area3D {
    GDCLASS(ShieldPowerup, Area3D);
    //! Required to be a valid godot class.
    static void _bind_methods();
public:
    //! Connect the body_entered observer.
    virtual void _enter_tree() override;
protected:
    //! Listener for this Area3D's body_entered observer. If the entered node is an EnemyCar, damage it.
    void body_entered(Node3D *body);
};
}

#endif // !SHIELD_POWERUP_HPP
